package vue;

// Native-backed emulation core implementation
class NativeVUE extends VUE {

    // Instance fields
    private byte[] pointer; // Context address in native memory



    ///////////////////////////////////////////////////////////////////////////
    //                             Constructors                              //
    ///////////////////////////////////////////////////////////////////////////

    // Default constructor
    NativeVUE() {
        construct();
    }



    ///////////////////////////////////////////////////////////////////////////
    //                            Public Methods                             //
    ///////////////////////////////////////////////////////////////////////////

    // Release any used resources
    public native void dispose();

    // Retrieve a copy of the ROM data
    public native byte[] getROM();

    // Determine whether the context is native-backed
    public native boolean isNative();

    // Perform a read operation
    public native boolean read(int address, byte[] data, int offset,
        int length);

    // Provide new ROM data
    public native boolean setROM(byte[] data, int offset, int length);



    ///////////////////////////////////////////////////////////////////////////
    //                            Private Methods                            //
    ///////////////////////////////////////////////////////////////////////////

    // Native constructor
    private native void construct();

}
